

/////////////thread stuff//////////////

public class LThread {
	
	public Thread timerThread;
  	public volatile boolean noStopRequested;
  	public boolean paused;
 	public final Object pauseLock = new Object();
	public Updateable object;
	public int deltaTime;

LThread(Updateable inObject, int inDeltaTime) {
	object = inObject;
	deltaTime = inDeltaTime;
}
public void startThread() {
     		paused = true;
     		noStopRequested = true;

     		// Use this inner class to hide the public run method
    		 Runnable r = new Runnable() {
      			 public void run() {
       			  runWork();
      			 }
     		};
    		 timerThread = new Thread(r, "Timer");
    		 timerThread.start();
     		  }
public void stopThread() {
    	noStopRequested = false;
   	 timerThread.interrupt();
      }


public void runWork() { 

    try {
        while ( noStopRequested ) {
        waitWhilePaused();
	object.update();
	Thread.sleep(deltaTime);
      }
    } catch ( InterruptedException x ) {
      // reassert interrupt
     Thread.currentThread().interrupt();
     System.out.println("interrupt and return from run");
    }
  }

  public void setPaused(boolean newPauseState) {
    synchronized ( pauseLock ) {
      if ( paused != newPauseState ) {
        paused = newPauseState;
        pauseLock.notifyAll();
      }
    }
  }

  public void waitWhilePaused() throws InterruptedException {
    synchronized ( pauseLock ) {
      while ( paused ) {
        pauseLock.wait();
      }
    }
  }

}